AddCSLuaFile()

ENT.Type = "anim"
ENT.Base = "base_anim"
 
ENT.PrintName= "Rock Bag"
ENT.Author= "SweptThrone"
ENT.Contact= "http://discord.gg/Tg8SUDv"
ENT.Purpose= ""
ENT.Instructions= ""
ENT.Spawnable = true
ENT.AdminSpawnable = false
ENT.Category = "STuff"

function ENT:SetupDataTables()
    self:NetworkVar( "Int", 0, "Ores" )
    self:NetworkVar( "Int", 1, "Rhodium" )
    self:NetworkVar( "Int", 2, "Platinum" )
    self:NetworkVar( "Int", 3, "Gold" )
    self:NetworkVar( "Int", 4, "Diamond" )
    self:NetworkVar( "Entity", 0, "Miner" )

    if SERVER then
        self:SetOres( 0 )
        self:SetRhodium( 0 )
        self:SetPlatinum( 0 )
        self:SetGold( 0 )
        self:SetDiamond( 0 )
    end
end

if CLIENT then

    local bagColors = {
        [ "ores" ] = Color( 64, 64, 64, 192 ),
        [ "diamond" ] = Color( 0, 128, 128, 192 ),
        [ "gold" ] = Color( 128, 128, 0, 192 ),
        [ "rhodium" ] = Color( 96, 96, 96, 192 ),
        [ "platinum" ] = Color( 0, 64, 128, 192 )
    }

    function ENT:Draw()
	    self:DrawModel()

        local pos = self:GetPos()
        pos = pos - self:GetRight() * 6.1
        local ang = self:GetAngles()
        ang:RotateAroundAxis( self:GetForward(), -90 )
        ang:RotateAroundAxis( self:GetRight(), 180 )

        local txt = ( IsValid( self:GetMiner() ) and self:GetMiner():Name() .. "'s" or "Anonymous" ) .. " Rock Bag"

        cam.Start3D2D( pos, ang, 0.1 )
            -- name plate
            surface.SetDrawColor( 0, 0, 0, 192 )
            surface.DrawRect( -155, -70, 310, 40 )
            surface.SetTextColor( Color( 255, 255, 255, 255 ) )
            surface.SetFont( "ChatFont" )
            surface.SetTextPos( -surface.GetTextSize( txt ) / 2, -60 )
            surface.DrawText( txt )

            -- ore plate
            surface.SetDrawColor( bagColors.ores )
            surface.DrawRect( -155, -30, 155, 125 )
            surface.SetTextColor( Color( 255, 255, 255, 255 ) )
            surface.SetFont( "CloseCaption_Normal" )
            surface.SetTextPos( -75 - surface.GetTextSize( self:GetOres() ) / 2, 10 )
            surface.DrawText( self:GetOres() )
            
            -- plat plate
            surface.SetDrawColor( bagColors.platinum )
            surface.DrawRect( 0, -30, 78, 62 )

            surface.SetTextPos( 40 - surface.GetTextSize( self:GetPlatinum() ) / 2, -15 )
            surface.DrawText( self:GetPlatinum() )
            -- rhodium plate
            surface.SetDrawColor( bagColors.rhodium )
            surface.DrawRect( 78, -30, 77, 62 )
            
            surface.SetTextPos( 115 - surface.GetTextSize( self:GetRhodium() ) / 2, -15 )
            surface.DrawText( self:GetRhodium() )
            -- gold plate
            surface.SetDrawColor( bagColors.gold )
            surface.DrawRect( 0, 32, 78, 62 )
            
            surface.SetTextPos( 40 - surface.GetTextSize( self:GetGold() ) / 2, 50 )
            surface.DrawText( self:GetGold() )
            -- diamond plate
            surface.SetDrawColor( bagColors.diamond )
            surface.DrawRect( 78, 32, 77, 62 )
        
            surface.SetTextPos( 115 - surface.GetTextSize( self:GetDiamond() ) / 2, 50 )
            surface.DrawText( self:GetDiamond() )
        cam.End3D2D()
    end
end

if SERVER then
    function ENT:Initialize()
    
        self:SetModel( "models/props_c17/SuitCase001a.mdl" )
        self:PhysicsInit( SOLID_VPHYSICS )
        self:SetMoveType( MOVETYPE_VPHYSICS )
        self:SetSolid( SOLID_VPHYSICS )

        local phys = self:GetPhysicsObject()
        if (phys:IsValid()) then phys:Wake() end
        self:SetUseType( SIMPLE_USE )

    end
    
    function ENT:Use( ply )
        ply:EmitSound( "items/itempickup.wav" )
        ply:SetNWInt( "HeldOres", ply:GetNWInt( "HeldOres", 0 ) + self:GetOres() )
		ply:SetNWInt( "HeldDiam", ply:GetNWInt( "HeldDiam", 0 ) + self:GetDiamond() )
		ply:SetNWInt( "HeldGold", ply:GetNWInt( "HeldGold", 0 ) + self:GetGold() )
		ply:SetNWInt( "HeldRhod", ply:GetNWInt( "HeldRhod", 0 ) + self:GetRhodium() )
		ply:SetNWInt( "HeldPlat", ply:GetNWInt( "HeldPlat", 0 ) + self:GetPlatinum() )
        self:Remove()
    end

    function ENT:PhysicsCollide( tab, col )
        local ent = tab.HitEntity
        if ent:GetClass() == "st_rockbag" and ent:GetMiner() == self:GetMiner() and not self.HasTouched and not ent.HasTouched then
            self.HasTouched = true 
            ent.HasTouched = true
            local giver, rec
            if self:GetVelocity():Length() > ent:GetVelocity():Length() then
                giver = self
                rec = ent
            else
                giver = ent
                rec = self
            end
            rec:SetOres( rec:GetOres() + giver:GetOres() )
            rec:SetDiamond( rec:GetDiamond() + giver:GetDiamond() )
            rec:SetGold( rec:GetGold() + giver:GetGold() )
            rec:SetRhodium( rec:GetRhodium() + giver:GetRhodium() )
            rec:SetPlatinum( rec:GetPlatinum() + giver:GetPlatinum() )
            giver:Remove()
            rec.HasTouched = false
        end
    end

end